﻿/*
 * main.c
 *
 *  Created on: 16.02.2017
 *      Author: Michal
 */
#include <avr/io.h>
#include <avr/interrupt.h>

#define temperature 0
#define pressure 1
#define kropka 0b11111011

const unsigned char cyfra[10]={0b00000101,0b11011101,0b01000110,0b01010100,0b10011100,0b00110100,0b00100100,0b01011101,0b00000100,0b00010100};
const unsigned char anoda[4] = {0b00000111,0b00001011,0b00001101,0b00001110};

volatile int32_t pw,tw,czas;

volatile uint8_t i=0,j=0,stan=0;

void wait(void)
{
	volatile uint8_t x,y;

	for(x=0;x<5;x++)
	{
		for(y=0;y<20;y++)
		{

		}
	}
}

void send_start_cond(void)
{
	TWCR = (1<<TWSTA)| (1<<TWINT)|(1<<TWEN); // start transmisji
	while(!(TWCR & (1<<TWINT)));
	while((TWSR & 0xF8)!=0x08);
}

void send_restart_cond(void)
{
	TWCR = (1<<TWSTA)| (1<<TWINT)|(1<<TWEN);
	while(!(TWCR & (1<<TWINT)));
	while((TWSR & 0xF8)!=0x10);
}



void send_data(uint8_t data)
{
	TWDR = data;
	TWCR = (1<<TWINT) | (1<<TWEN);
	while (!(TWCR & (1<<TWINT)));
	while((TWSR & 0xF8)!=0x28);

}

void send_adress_w(uint8_t addr)
{
	TWDR = addr;
	TWCR = (1<<TWINT) | (1<<TWEN);
	while (!(TWCR & (1<<TWINT)));
	while((TWSR & 0xF8)!=0x18);

}


void send_adress_r(uint8_t addr)
{
	TWDR = addr;
	TWCR = (1<<TWINT) | (1<<TWEN);
	while (!(TWCR & (1<<TWINT)));
	while((TWSR & 0xF8)!=0x40);

}


void start_measure(uint8_t type)
{
	send_start_cond();

	send_adress_w((uint8_t)0xEE);// BMP180 adress write

	send_data((uint8_t)0xF4); //BMP180 control register

	if(type == temperature)
		send_data((uint8_t)0x2E); // temp
	if(type == pressure)
		send_data((uint8_t)0x34); //presure - 0oss - ultra low power mode

	//end of transmission
	TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO);
	wait();
}

uint16_t get_data(uint8_t reg_addr)// MSB
{
	uint16_t value=0;


	send_start_cond();

	send_adress_w((uint8_t)(0xEE));
	send_data((uint8_t)(reg_addr));


	send_restart_cond();
	send_adress_r((uint8_t)(0xEF));

	TWCR = (1<<TWINT) | (1<<TWEN) |(1<<TWEA);
	while (!(TWCR & (1<<TWINT)));
	while((TWSR & 0xF8)!=0x50);


	value = (uint16_t)(TWDR<<8);


	TWCR = (1<<TWINT) | (1<<TWEN);
	while (!(TWCR & (1<<TWINT)));
	while((TWSR & 0xF8)!=0x58);

	value |= TWDR;

	TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO); //stop
	wait();

	return value;
}



int32_t get_temperature(void)
{
	int32_t nctemperature=0;
	start_measure(temperature);
	nctemperature = (int32_t)(get_data(0xF6));
	return nctemperature ;

}

int32_t get_pressure(void)
{
	int32_t ncpressure=0;
	start_measure(pressure);
	ncpressure = (int32_t)(get_data(0xF6));
	return ncpressure ;

}

ISR(TIMER0_OVF_vect) // przerwanie od licznika
{

czas++;

// zmiana czasu wyświetlania temperatury i ciśnienia
if(czas==5000)
{
	czas=0;
	stan ^= 1;
}

j++;

if((j%2)==0)
{
	j=0;
	if(i==0)
	{
		if(stan)
		{
			if(pw<10000)
				PORTD =  cyfra[ (uint8_t)((pw)%10)];
			else
				PORTD =  cyfra[ (uint8_t)((pw/10)%10)];
		}
		else
		PORTD =  cyfra[ (uint8_t)(tw%10)];

		PORTC = 0xff;
		PORTC = anoda[3];


	}
	if(i==1)
	{
		if(stan)
		{
			if(pw<10000)
				PORTD =  cyfra[ (uint8_t)(((pw)%100)/10)]&0b11111011;
			else
				PORTD =  cyfra[ (uint8_t)(((pw/10)%100)/10)];
		}
		else
		PORTD =  cyfra[ (uint8_t)((tw%100)/10)]&0b11111011;

		PORTC = 0xff;
		PORTC = anoda[2];


	}
	if(i==2)
	{
		if(stan)
		{
			if(pw<10000)
				PORTD =  cyfra[ (uint8_t)(((pw)%1000)/100)];
			else
				PORTD =  cyfra[ (uint8_t)(((pw/10)%1000)/100)];
		}
		else
		PORTD =  cyfra[ (uint8_t)((tw%1000)/100)];
		PORTC = 0xff;

		PORTC = anoda[1];


	}
	if(i==3)
	{
		if(stan)
		{
		if(pw<10000)
			PORTD = cyfra[(uint8_t)((pw)/1000)];
		else
			PORTD = cyfra[(uint8_t)((pw/10)/1000)];
		}
		else
		PORTD = 0xff;
		PORTC = 0xff;
		PORTC = anoda[0];


	}
	i++;
		if(i==4)
			i=0;
}
}

int main(void)
{


 int32_t t=0,p=0;
 int16_t AC1 = 0,AC2=0,AC3=0,B1=0,B2=0,MB=0,MC=0,MD=0;
 uint16_t AC4=0,AC5=0,AC6=0;
 int32_t x1=0,x2=0,x3=0,b3=0,b5=0,b6=0,nc_temp=0,nc_press=0;
 uint32_t b4=0,b7=0;

// inicjalizacja portów we/wy
DDRD = 0xff;
DDRB |= (1<<PB0);
DDRC |=0b00001111;

// inicjalizacja timera
TCCR0 |= (1<<CS01); //no psc
TIMSK |= (1<<TOIE0); // interr. en

// inicjalizacja i2c
// sck = 10kHz
TWBR = 11;
TWSR |= ((1<<TWPS0) |(1<<TWPS1));

//read  coefficients
AC1 = (int16_t)(get_data(0xAA));
AC2 = (int16_t)(get_data(0xAC));
AC3 = (int16_t)(get_data(0xAE));
AC4 = (uint16_t)(get_data(0xB0));
AC5 = (uint16_t)(get_data(0xB2));
AC6 = (uint16_t)(get_data(0xB4));
B1 = (int16_t)(get_data(0xB6));
B2 = (int16_t)(get_data(0xB8));
MB = (int16_t)(get_data(0xBA));
MC = (int16_t)(get_data(0xBC));
MD = (int16_t)(get_data(0xBE));

nc_temp = get_temperature();
nc_press = get_pressure();

// obliczenia temperatury
x1 = (int32_t)((((int32_t)(nc_temp) - (uint32_t)(AC6)) * (uint32_t)(AC5)>>15));
x2 = (int32_t)(((int32_t)(MC)<<11)/(int32_t)(x1+(int32_t)(MD)));
b5 = x1+x2;
t= (b5+8)>>4;

//obliczenia ciśnienia
b6 = b5 - 4000;
	x1 = ((int32_t)(B2)*((b6*b6)>>12))>>11;
	x2 = ((int32_t)(AC2)*b6)>>11;
	x3 = x1+x2;
	b3 = (((int32_t)(AC1))*4 + x3 + 2)>>2;
	x1 = ((int32_t)(AC3) * b6)>>13;
	x2 = ((int32_t)(B1)*((b6*b6)>>12))>>16;
	x3 = (x1+x2+2)>>2;
	b4 = (uint32_t)(((uint32_t)(AC4) * (uint32_t)(x3+32768))>>15);
	b7 = (uint32_t)(((uint32_t)(nc_press)-b3)*50000);

	if(b7<0x80000000)
		p=(b7*2)/b4;
	else
		p=(b7/b4)*2;

	x1 = (p>>8)*(p>>8);
	x1 = (x1*3038)>>15;
	x2 = (-7357*p)>>15;
	p=p+((x1+x2+3791)>>4);

sei();

pw=p/100;
tw = t;

while(1)
	{
	nc_temp = get_temperature();
	nc_press = get_pressure();

	x1 = (int32_t)((((int32_t)(nc_temp) - (uint32_t)(AC6)) * (uint32_t)(AC5)>>15));
	x2 = (int32_t)(((int32_t)(MC)<<11)/(int32_t)(x1+(int32_t)(MD)));
	b5 = x1+x2;
	t= (b5+8)>>4;

	b6 = b5 - 4000;
	x1 = ((int32_t)(B2)*((b6*b6)>>12))>>11;
	x2 = ((int32_t)(AC2)*b6)>>11;
	x3 = x1+x2;
	b3 = (((int32_t)(AC1))*4 + x3 + 2)>>2;
	x1 = ((int32_t)(AC3) * b6)>>13;
	x2 = ((int32_t)(B1)*((b6*b6)>>12))>>16;
	x3 = (x1+x2+2)>>2;
	b4 = (uint32_t)(((uint32_t)(AC4) * (uint32_t)(x3+32768))>>15);
	b7 = (uint32_t)(((uint32_t)(nc_press)-b3)*50000);

	if(b7<0x80000000)
		p=(b7*2)/b4;
	else
		p=(b7/b4)*2;

	x1 = (p>>8)*(p>>8);
	x1 = (x1*3038)>>15;
	x2 = (-7357*p)>>15;
	p=p+((x1+x2+3791)>>4);

	pw=p/10;
	tw = t;

	}



}

